#include "defs.h"

/********************************************************************/
/*************Criba de Eratostenes mediante punteros*****************/
/********************************************************************/
/* Por Jose Mariscal Prieto, Practica Numero 10. */

/* La Criba de Eratostenes permite obtener numeros primos menores que
uno dado. Si suponemos que el numero es 100, n=100. En la criba se
escriben los numeros entre 1 y n.
Tachamos 1 como primo, 2 y todos sus multiplos, 3 y todos sus multiplos...
El progra ma utilizara un vector de n componentes (dinamico) para crear
la criba.
El programa consta de las siguientes funciones:

* criba: calcula la criba
* reserva: reserva la criba
* escribe: escribe la criba ya sea en fichero o por pantalla

La linea de comandos sera la siguiente.
criba	ejecuta el programa normalmente
criba -h 	mostrara la ayuda del programa
criba n comprueba si n es positivo, dando un error si no lo es y calculara
los primos menores que n si es posible.
criba n fich comprueba si n es positivo, dando un error si no lo es y
calculara los primos menores que n si es posible guardando el resultado en
el fichero fich con una cabecera explicativa.


*/


/* Funcion Principal */
/* recibe un numero entero y caracteres, que seran las opciones del */
/* programa */


main (int entero, char *argu[])
{
int *punt, num;
char fich[20];
if(entero>1)
	{
	/* si el argumento que recibe es -h muestra la ayuda */
	if(strcmp(argu[1],"-h")==0 || entero>1)
		{
		printf("\a\nPractica 10: La Criba de Eratostenes");
		printf("\n\nMenu de Ayuda");
		printf("\nPara ejecutar el programa criba");
		printf("\ncriba -h              Muestra esta ayuda");
		printf("\ncriba n               Muestra los numeros primos menores que n");
		printf("\ncriba n fichero       Crea un fichero de texto que genera la salida de los");
		printf("\nnumeros menores que n\n\n");
		printf("\nOjo no introduzca numeros muy grandes! se reducira drasticamente");
		printf("\nel rendimiento del sistema\n\n");
		}
/* funcion atoi, ASCII TO INT! */		
	num=atoi(argu[1]);
	/* verifica que el numero introducido ha de ser mayor que cero */
	if(num<0)
		{
		printf("\nOjo! n ha de ser entero, positivo");
		}
	}
else
	{
	system("clear");
	printf("Introduce el numero n para mostrar los numeros primos anteriores a el:\n");
	scanf("%d", &num);
	if(num<0)
		{
		printf("\nOjo! n tiene que ser entero positivo");
		}
	}
reserva(&punt, num);

criba(punt, num);
escritura(punt, num, entero, argu[2]);
printf("\nRegresando al interprete de comandos...\n\n");
}
