/* funcion descalificaciones */
/* Es de tipo void no devuelve nada */
/* borra de la lista una serie de pilotos pasados utilizando una lista cuyo
 unico campo es el nombre del piloto o bien aquellos pilotos que han
 sobrepasado un tiempo total maximo. La funcion dependiendo del valor de
 sus parametros hara una cosa u otra, o bien ambas. */
/* recibe **l un puntero doble a la estructura rally, que contiene la
 lista con los datos de los pilotos de la clasificacion */
/* recibe *nombres un puntero a la estructura nombre (contenida en nombre.h) 
que contiene la lista de los nombres de los pilotos a borrar */
/* Y un entero tiempo que recoge el valor del tiempo maximo a partir
 del cual se borraran los pilotos que lo pasen */

#include "listas.h"

void descalificaciones(struct rally **l,struct nombre *nombres,int tiempo)
{
struct rally *auxiliar;
if(vacia_nombres(nombres)==NO)
	while(nombres!=NULL)
		{
		borrar_por_piloto(l,nombres->piloto);
		nombres=nombres->siguiente;
		}
if(tiempo!=-1)
	{
	auxiliar=*l;
	while(auxiliar!=NULL)
		{
		if(auxiliar->tiempo>tiempo)
			borrar_por_piloto(l,auxiliar->piloto);
		auxiliar=auxiliar->siguiente;
		}
	}
}
