/* insertar_por_piloto */
/* es de tipo void y no devuelve nada inserta un piloto por orden alfabetico */
/* recibe un puntero doble **l a la estructura rally donde recoge
la lista donde sera insertado */
/* recibe una estructura insertado de tipo rally, que contiene los datos del
piloto a insertar */

#include "malloc.h"
#include "listas.h"

void insertar_por_piloto(struct rally **l,struct rally insertado)
{
struct rally *nuevo,*anterior,*auxiliar,inser2;
nuevo=(struct rally*)malloc(sizeof(struct rally));
strcpy(nuevo->piloto,insertado.piloto);
strcpy(nuevo->marca,insertado.marca);
strcpy(nuevo->modelo,insertado.modelo);
nuevo->tiempo=insertado.tiempo;
if(vacia(*l)==SI)
	{
	nuevo->siguiente=NULL;
	*l=nuevo;
	}
else
	{
	/* comparo asi los nombres de los pilotos, si es mayor lo asigno
	al sieguiente */
	if(strcmp(insertado.piloto,(*l)->piloto)<=0)
		{
		nuevo->siguiente=*l;
		*l=nuevo;
		}
	else
	/* si no lo asigno al anterior y creo un auxiliar que me sirva para guardar datos */
		{
		anterior=*l;
		auxiliar=(*l)->siguiente;
		while(auxiliar!=NULL)
			{
			/* si es menor se sale */
			if(strcmp(insertado.piloto,auxiliar->piloto)<0)
				break;
			/* si es mayor hace esto */
			else
				{
				anterior=auxiliar;
				auxiliar=auxiliar->siguiente;
				}
			}
		nuevo->siguiente=auxiliar;
		anterior->siguiente=nuevo;
		}
	}
}
