/* listas.h */
/* archivos de cabecera y declaraciones */

#include "stdio.h"
#include "stdlib.h"

#define SI      1
#define NO      0

struct rally
{
char piloto[40],marca[30],modelo[30];
int tiempo;
struct rally *siguiente;        /* puntero a la siguiente entrada */
struct rally *anterior;         /* puntero a la entrada anterior */
};

struct nombre
{
char piloto[40];
struct nombre *siguiente;
};

void crear(struct rally**);
void crear_nombres(struct nombre**);
int menu(void);
void pulsartecla(void);
int vacia(struct rally*);
int vacia_nombres(struct nombre*);
void insertar_al_principio(struct rally**,struct rally);
void insertar_al_final(struct rally**,struct rally);
void insertar_al_final_nombres(struct nombre**,char*);
void visualizar_piloto(struct rally*);
void insertar_tiempo_total(struct rally**,struct rally);
void buscar_por_piloto(struct rally*,char*);
void borrar_por_piloto(struct rally**,char*);
void liberar_memoria(struct rally**);
void liberar_memoria_recursivo(struct rally**);
void visualizar_marca(struct rally*,char*);
void grabar_lista(struct rally*,char*);
void recuperar_lista(struct rally**,char*);
int visualizar_cabeza_cola(struct rally*);
void insertar_tiempo_total(struct rally**,struct rally);
void insertar_por_piloto(struct rally**,struct rally);
void penalizaciones(struct rally**,struct rally);
int visualizar_cola_cabeza(struct rally*);
void descalificaciones(struct rally**,struct nombre*,int);
void liberar_memoria_nombres(struct nombre**);
void invertir_lista(struct rally**);
