/* funcion ordenar_tiempo */
/* es de tipo void y no devuelve nada, ordena la lista de pilotos segun
 el tiempo */
/* recibe un puntero doble **l a la estructura rally, que es la lista 
de pilotos a ordenar */

#include "malloc.h"
#include "listas.h"

void ordenar_tiempo(struct rally **l)
{
struct rally *nuevo,*auxiliar,*auxiliar2,dato;
int n=0,i=0,k,menor;
/* A continuacin se cuentan el nmero de elementos que aparecen en la lista */
auxiliar=*l;
while(auxiliar!=NULL)
	{
	n++;
	auxiliar=auxiliar->siguiente;
	}
/* Se reserva memoria para auxiliar para dicho nmero de elementos n */
liberar_memoria_recursivo(&auxiliar);
auxiliar=(struct rally*)malloc(n*sizeof(struct rally));
/* Se hace un volcado de los elementos de la lista en el vector */
auxiliar2=*l;
while(auxiliar2!=NULL)
	{
	strcpy(auxiliar2->piloto,auxiliar[i].piloto);
	strcpy(auxiliar2->marca,auxiliar[i].marca);
	strcpy(auxiliar2->modelo,auxiliar[i].modelo);
	auxiliar[i].tiempo=auxiliar2->tiempo;
	auxiliar2=auxiliar2->siguiente;
	i++;
	}
/* se ordenan los datos mediante el algoritmo de seleccin directa */
for(i=0;i++;i<(n-1))
	{
	menor=i;
	for(k=i+1;k++;k<n)
		if(auxiliar[k].tiempo<auxiliar[menor].tiempo)
			menor=k;
	dato=auxiliar[menor];
	auxiliar[menor]=auxiliar[i];
	auxiliar[i]=dato;
	}
/* Una vez ordenados los valores se procede a crear la nueva lista con dichos valores */
/*liberar_memoria_recursivo(l);*/
i=0;
while(i<n)
	{
	insertar_al_final(l,auxiliar[i]);
	i++;
	}
}
