! Jose Mariscal Prieto
! Metodologia de la Programacion. Practica 13. Fortran
! Nombre del programa fortran90


! GOTOS:  1 menu de opciones
!	 10 monticulo
!	 20 maximin
!	100 sale del programa

! Comenzamos un programa para fortran 90
      PROGRAM fortran90

! declaracion de las variables
      INTEGER opc,longitud,filas,columnas,i,j,izquierda,derecha
      INTEGER auxiliar
      REAL vector(10),matriz(5,5),max

! La etiqueta siguiente (1) sirve para volver a visualizar el menu en el
! caso de opcion equivocada.

1     PRINT *,'------------------------------------------------------'
      PRINT *,'|                 MENU DE OPCIONES                   |'
      PRINT *,'|----------------------------------------------------|'
      PRINT *,'|   1. Metodo de ordenacion interna del monticulo    |'
      PRINT *,'|   2. Valor maximin de una matriz                   |'
      PRINT *,'|   3. Salir del programa                            |'
      PRINT *,'------------------------------------------------------'
      PRINT *,''
      PRINT *,'Elige una opcion:'
      READ *,opc
! 10 monticulo, 20 valor maximin, 100 salida de programa
      GOTO (10,20,100) opc
! Si la opcion no es correcta vete a la linea 1
      GOTO 1

! Metodo de ordenacion interna del monticulo
10    PRINT *,'------------------------------------------------------'
      PRINT *,'|    METODO DE ORDENACION INTERNA DEL MONTICULO      |'
      PRINT *,'------------------------------------------------------'
      PRINT *,''
      PRINT *,'Introduce el numero de elementos del vector:'
      READ *,longitud
      IF (longitud .gt. 10.0) THEN
         PRINT *,'El vector no puede ser mayor de 10 elementos.'
         PRINT *,'Presione Intro para continuar...'
         READ *
         GOTO 1
      END IF
      DO 2 , i=1 , longitud
         PRINT *,'Introduce el elemento ',i,' del vector:'
         READ *,vector(i)
2     CONTINUE
! Comienza el algoritmo del monticulo
      izquierda=(longitud/2)+1
      derecha=longitud
! Creacion del monticulo
      DO while (izquierda .gt. 1)
         izquierda=izquierda-1
         CALL criba(izquierda,derecha,vector)
      END DO
      DO while (derecha .gt. 1)
         auxiliar=vector(1)
         vector(1)=vector(derecha)
         vector(derecha)=auxiliar
         derecha=derecha-1
         CALL criba(izquierda,derecha,vector)
      END DO
      PRINT *,'Los elementos del vector ordenados son:'
      DO 3 , i=1 , longitud
         PRINT *,vector(i)
3     CONTINUE
      PRINT *,'Pulse ENTRAR para continuar...'
      READ *
      GOTO 1

! Valor maximin de una matriz
20    PRINT *,''
      PRINT *,'VALOR MAXIMIN DE UNA MATRIZ'
      PRINT *,'-----------------------------------------------------'
      PRINT *,''
      PRINT *,'Introduce el numero de filas de la matriz:'
      READ *,filas
      IF (filas .gt. 5.0 .or. filas .lt. 1) THEN
         PRINT *,'Las filas han de ser mayores que 1 y menores de 5.'
         PRINT *,'Pulsa ENTRAR para continuar...'
         READ *
! Vete a la linea 1, error
         GOTO 1
      END IF
      PRINT *,'Introduce el numero de columnas de la matriz:'
      READ *,columnas
      IF (columnas .gt. 5.0 .or. columnas .lt. 1) THEN
         PRINT *,'Las columnas han de ser mayores que 1 menores de 5.'
         PRINT *,'Pulsa ENTRAR para continuar...'
         READ *
         GOTO 1
      END IF
      DO 4 , i=1 , filas
         DO 5 , j=1 , columnas
            PRINT *,'Introduce el elemento ',i,',',j,' de la matriz.'
            READ *,matriz(i,j)
5        CONTINUE
4     CONTINUE
      CALL maximin(matriz,filas,columnas)
      GOTO 1

! Comienzan las subrutinas 

CONTAINS

! El compilador da un error con la linea 47 si denomido al vector v integrer
! que es la linea que llama a la subrutina criba
! Ha de ser REAL!!!! tienen que ser el mismo tipo de variables ;-)

! Comienza la subrutina criba
      SUBROUTINE criba(izquierda,derecha,v)
! Declaro las variables a usar en la subrutina
      INTEGER izquierda,derecha,i,j,x,salida
      REAL v(10)
      i=izquierda
      j=2*i
      x=v(i)
      salida=0
      DO while (j .le. derecha .and. salida .eq. 0)
         IF (j .lt. derecha) THEN
            IF (v(j) .gt. v(j+1)) THEN
               j=j+1
            END IF
         END IF
         IF (x .le. v(j)) THEN
            salida=1
         ELSE
            v(i)=v(j)
            i=j
            j=2*i
         END IF
      END DO
      v(i)=x
      RETURN
      END SUBROUTINE criba

! Subrutina maximin

      SUBROUTINE maximin(matriz,filas,columnas)

! Declaro las variables a utilizar.

      INTEGER filas,columnas,i,j
      REAL matriz(5,5),min(5),max
      CHARACTER fichero*10
      DO 6 , i=1 , filas
         min(i)=matriz(i,1)
         DO 7, j=2 , columnas
            IF (matriz(i,j) .lt. min(i)) THEN
               min(i)=matriz(i,j)
            END IF
7        CONTINUE
6     CONTINUE
      max=min(1)
      DO 8 , i=2 , filas
         IF(max .lt. min(i)) THEN
            max=min(i)
         END IF
8     CONTINUE
! el simbolo amplesand sirve para unir dos lineas muy largas, ojo &
& no mas largas de 132 caracteres.
      PRINT *,'Introduce el nombre de un fichero para guardar la matriz & 
      & y el maximin:'
      READ '(a)', fichero
      OPEN(1,file=fichero,err=70)
      DO 11 i=1 , filas
         DO 12 j=1 , columnas
           WRITE (1,*) i,',',j,': ',matriz(i,j)
12       CONTINUE
11    CONTINUE
      WRITE (1,*) 'Valor maximin de la matriz: ',max
      CLOSE(1)
      PRINT *,'El valor maximin de la matriz es ',max
      GOTO 80

! Sentencia de control de errores de apertura
70    PRINT *,'Error al abrir el fichero ',fichero

! Final de la subrutina
80    END SUBROUTINE maximin

! Fin del programa
100    END PROGRAM fortran90
